/// <summary>
/// Programmer:  Avery T. Horton, Jr.  aka TheRumpledOne,  
/// DONATIONS AND GIFTS ACCEPTED 
/// P O BOX 43575, TUCSON, AZ 85733
///
/// Indicator: TRO SM BattleLines
/// Converted to NinjaTrader by cvax
/// </summary>
#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
	/// <summary>
	/// Pivot Points.
	/// </summary>
	[Description("Pivot Points with TRO's Battle Lines")]
	[Gui.Design.DisplayName("TRO's Slot Machine Battle Lines")]
	public class TRO_SM_BattleLines : Indicator
	{
		#region Variables
		private	SolidBrush[]	brushes			= { new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), 
													new SolidBrush(Color.Black) };
		private	double			currentClose	= 0;
		private DateTime		currentDate		= Cbi.Globals.MinDate;
		private DateTime		currentMonth	= Cbi.Globals.MinDate;
		private DateTime		currentWeek		= Cbi.Globals.MinDate;
		private	double			currentHigh		= double.MinValue;
		private	double			currentLow		= double.MaxValue;
		private Data.PivotRange pivotRangeType	= PivotRange.Daily;
		private bool			labels			= true;
		private bool			battlelabels	= true;
		private bool			battlelines		= true;
		private	double			pp				= 0;
		private	double			r1				= 0;
		private	double			r2				= 0;
		private	double			r3				= 0;
		private	double			r4				= 0;
		private	double			r5				= 0;
		private	double			s1				= 0;
		private	double			s2				= 0;
		private	double			s3				= 0;
		private	double			s4				= 0;
		private	double			s5				= 0;
		private	StringFormat	stringFormat	= new StringFormat();
		private int				width			= 370;
		
		private Pen				rpen;
		private Pen				bpen;
		#endregion
		protected override void Initialize()
		{
			rpen = new Pen(Color.Red, 2);
			bpen = new Pen(Color.Blue, 2);
			Add(new Plot(rpen,		"R5"));
			Add(new Plot(rpen,		"R4"));
			Add(new Plot(rpen,		"R3"));
			Add(new Plot(rpen,		"R2"));
			Add(new Plot(rpen,		"R1"));
			Add(new Plot(new Pen(Color.DarkGreen, 2),	"PP"));
			Add(new Plot(bpen,	"S1"));
			Add(new Plot(bpen,	"S2"));
			Add(new Plot(bpen,	"S3"));
			Add(new Plot(bpen,	"S4"));
			Add(new Plot(bpen,	"S5"));
			if ( battlelines == true)
			{
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Buyers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"Sellers 20"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
				Add(new Plot(Color.Gray,	"50 Yd"));
			}
			
			AutoScale				= false;
			CalculateOnBarClose		= false;
			Overlay					= true;
			stringFormat.Alignment	= StringAlignment.Far;
		}

		/// <summary>
		/// Called on each bar update event (incoming tick)
		/// </summary>
		protected override void OnBarUpdate()
		{
			if (Bars == null)
				return; 
			if (!Session.IsIntraday(Bars.Period.Id) && Bars.Period.Id != PeriodType.Day)
				return;
			if (Bars.Period.Id == PeriodType.Day && pivotRangeType == PivotRange.Daily)
				return;
			if (Bars.Period.Id == PeriodType.Day && Bars.Period.Value > 1)
				return;

			if ((currentDate != Cbi.Globals.MinDate && pivotRangeType == PivotRange.Daily && Time[0].Date != currentDate)
				|| (currentWeek != Cbi.Globals.MinDate && pivotRangeType == PivotRange.Weekly && RoundUpTimeToPeriodTime(Time[0].Date, PivotRange.Weekly) != currentWeek) 
				|| (currentMonth != Cbi.Globals.MinDate && pivotRangeType == PivotRange.Monthly && RoundUpTimeToPeriodTime(Time[0].Date, PivotRange.Monthly) != currentMonth)) 
			{
				pp				= (currentHigh + currentLow + currentClose) / 3;
				s1				= 2 * pp - currentHigh;
				r1				= 2 * pp - currentLow;
				s2				= pp - (currentHigh - currentLow);
				r2				= pp + (currentHigh - currentLow);
				s3				= pp - 2*(currentHigh - currentLow);
				r3				= pp + 2*(currentHigh - currentLow);
				s4				= pp - 3*(currentHigh - currentLow);
				r4				= pp + 3*(currentHigh - currentLow);
				s5				= pp - 4*(currentHigh - currentLow);
				r5				= pp + 4*(currentHigh - currentLow);
				currentClose	= Close[0]; 
				currentHigh		= High[0];
				currentLow		= Low[0];
			}
			else
			{
				currentClose	= Close[0]; 
				currentHigh		= Math.Max(currentHigh, High[0]);
				currentLow		= Math.Min(currentLow, Low[0]);
			}
			if (pivotRangeType == PivotRange.Daily)
				currentDate = Time[0].Date;
			if (pivotRangeType == PivotRange.Weekly)
				currentWeek = RoundUpTimeToPeriodTime(Time[0].Date, PivotRange.Weekly);
			if (pivotRangeType == PivotRange.Monthly)
				currentMonth = RoundUpTimeToPeriodTime(Time[0].Date, PivotRange.Monthly);

			if (pp != 0)
			{
				PP.Set(pp);
				R1.Set(r1);
				S1.Set(s1);
				R2.Set(r2);
				S2.Set(s2);
				R3.Set(r3);
				S3.Set(s3);
				R4.Set(r4);
				S4.Set(s4);
				R5.Set(r5);
				S5.Set(s5);
				if (battlelines == true)
				{
					BuyersR54.Set((r5-r4)*.20+r4);
					BuyersR43.Set((r4-r3)*.20+r3);
					BuyersR32.Set((r3-r2)*.20+r2);
					BuyersR21.Set((r2-r1)*.20+r1);
					BuyersR1PP.Set((r1-pp)*.20+pp);
					BuyersPPS1.Set((pp-s1)*.20+s1);
					BuyersS12.Set((s1-s2)*.20+s2);
					BuyersS23.Set((s2-s3)*.20+s3);
					BuyersS34.Set((s3-s4)*.20+s4);
					BuyersS45.Set((s4-s5)*.20+s5);
					SellersR54.Set((r5-r4)*.80+r4);
					SellersR43.Set((r4-r3)*.80+r3);
					SellersR32.Set((r3-r2)*.80+r2);
					SellersR21.Set((r2-r1)*.80+r1);
					SellersR1PP.Set((r1-pp)*.80+pp);
					SellersPPS1.Set((pp-s1)*.80+s1);
					SellersS12.Set((s1-s2)*.80+s2);
					SellersS23.Set((s2-s3)*.80+s3);
					SellersS34.Set((s3-s4)*.80+s4);
					SellersS45.Set((s4-s5)*.80+s5);
					FiftyR54.Set((r5-r4)*.50+r4);
					FiftyR43.Set((r4-r3)*.50+r3);
					FiftyR32.Set((r3-r2)*.50+r2);
					FiftyR21.Set((r2-r1)*.50+r1);
					FiftyR1PP.Set((r1-pp)*.50+pp);
					FiftyPPS1.Set((pp-s1)*.50+s1);
					FiftyS12.Set((s1-s2)*.50+s2);
					FiftyS23.Set((s2-s3)*.50+s3);
					FiftyS34.Set((s3-s4)*.50+s4);
					FiftyS45.Set((s4-s5)*.50+s5);
				}
			}
		}

		#region Properties
		/// <summary>
		/// </summary>
		[Description("Type of period for pivot points.")]
		[Category("Parameters")]
		public Data.PivotRange PivotRangeType 
		{
			get { return pivotRangeType; }
			set { pivotRangeType = value; }
		}

		/// <summary>
		/// </summary>
		[Description("Turn Pivot Point Labels On/Off.")]
		[Category("Battle Lines Settings")]
		public bool PivotLabels 
		{
			get { return labels; }
			set { labels = value; }
		}
		
		/// <summary>
		/// </summary>
		[Description("Turn Battle Line Labels On/Off.")]
		[Category("Battle Lines Settings")]
		public bool BattleLabels 
		{
			get { return battlelabels; }
			set { battlelabels = value; }
		}
		
		/// <summary>
		/// </summary>
		[Description("Turn Battle Lines On/Off.")]
		[Category("Battle Lines Settings")]
		public bool BattleLines 
		{
			get { return battlelines; }
			set { battlelines = value; }
		}
		
		/// <summary>
		/// </summary>
		[Description("Width of the pivot lines as # of bars.")]
		[Category("Battle Lines Settings")]
		public int Width
		{
			get { return width; }
			set { width = Math.Max(1, value); }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries PP
		{
			get { return Values[5]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R1
		{
			get { return Values[4]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R2
		{
			get { return Values[3]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R3
		{
			get { return Values[2]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R4
		{
			get { return Values[1]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries R5
		{
			get { return Values[0]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S1
		{
			get { return Values[6]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S2
		{
			get { return Values[7]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S3
		{
			get { return Values[8]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S4
		{
			get { return Values[9]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries S5
		{
			get { return Values[10]; }
		}

		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersR54
		{
			get { return Values[11]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersR43
		{
			get { return Values[12]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersR32
		{
			get { return Values[13]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersR21
		{
			get { return Values[14]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersR1PP
		{
			get { return Values[15]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersPPS1
		{
			get { return Values[16]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersS12
		{
			get { return Values[17]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersS23
		{
			get { return Values[18]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersS34
		{
			get { return Values[19]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries BuyersS45
		{
			get { return Values[20]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersR54
		{
			get { return Values[21]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersR43
		{
			get { return Values[22]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersR32
		{
			get { return Values[23]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersR21
		{
			get { return Values[24]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersR1PP
		{
			get { return Values[25]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersPPS1
		{
			get { return Values[26]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersS12
		{
			get { return Values[27]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersS23
		{
			get { return Values[28]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersS34
		{
			get { return Values[29]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries SellersS45
		{
			get { return Values[30]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyR54
		{
			get { return Values[31]; }
		}
		
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyR43
		{
			get { return Values[32]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyR32
		{
			get { return Values[33]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyR21
		{
			get { return Values[34]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyR1PP
		{
			get { return Values[35]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyPPS1
		{
			get { return Values[36]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyS12
		{
			get { return Values[37]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyS23
		{
			get { return Values[38]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyS34
		{
			get { return Values[39]; }
		}
				
		/// <summary>
		/// </summary>
		[Browsable(false)]
		[XmlIgnore]
		public DataSeries FiftyS45
		{
			get { return Values[40]; }
		}
		#endregion

		#region Miscellaneous
		private int GetDayOfWeek(DateTime date)
		{
			DateTime saturday = new DateTime(1776, 7, 4).AddDays(2);
			TimeSpan diff = date.Subtract(saturday);
			return (diff.Days % 7);
		}

		private DateTime RoundUpTimeToPeriodTime(DateTime time, PivotRange pivotRange)
		{
			if (pivotRange == PivotRange.Weekly)
			{
				DateTime periodStart = time.AddDays((6-GetDayOfWeek(time)));
				return periodStart.Date.AddDays(System.Math.Ceiling(System.Math.Ceiling(time.Date.Subtract(periodStart.Date).TotalDays) / 7) * 7).Date;
			}
			else if (pivotRange == PivotRange.Monthly)
			{
				DateTime result = new DateTime(time.Year, time.Month, 1); 
				return result.AddMonths(1).AddDays(-1);
			}
			else
				return time;
		}

		/// <summary>
		/// </summary>
		/// <param name="graphics"></param>
		/// <param name="bounds"></param>
		/// <param name="min"></param>
		/// <param name="max"></param>
		public override void Plot(Graphics graphics, Rectangle bounds, double min, double max)
		{
			if (Bars == null || ChartControl == null)
				return;

			int	barWidth = ChartControl.ChartStyle.GetBarPaintWidth(ChartControl.BarWidth);
			for (int seriesCount = 0; seriesCount < Values.Length; seriesCount++)
			{
				SolidBrush		brush				= brushes[seriesCount];
				DateTime		lastDate			= Cbi.Globals.MinDate;
				DateTime		lastWeek			= Cbi.Globals.MinDate;
				DateTime		lastMonth			= Cbi.Globals.MinDate;
				int				firstX				= -1;
				int				lastX				= -1;
				int				lastY				= -1;
				int				xcounter			= 0;
				SmoothingMode	oldSmoothingMode	= graphics.SmoothingMode;
				GraphicsPath	path				= new GraphicsPath();
				Gui.Chart.Plot	plot				= Plots[seriesCount];
				DataSeries	series				= (DataSeries) Values[seriesCount];
				
				if (brush.Color != plot.Pen.Color)	
					brush = new SolidBrush(plot.Pen.Color);

				for (int count = ChartControl.BarsPainted - 1; count >= ChartControl.BarsPainted - Math.Min(ChartControl.BarsPainted, Width); count--)
				{
					
					int idx = ChartControl.LastBarPainted - ChartControl.BarsPainted + 1 + count;
					if (idx - Displacement < 0 || idx - Displacement >= Bars.Count || (!ChartControl.ShowBarsRequired && idx - Displacement < BarsRequired))
						continue;
					else if (!series.IsValidPlot(idx))
						continue;

					if (pivotRangeType == PivotRange.Daily && lastDate == Cbi.Globals.MinDate) 
						lastDate = Bars.Get(idx).Time.Date;
					else if (pivotRangeType == PivotRange.Weekly && lastWeek == Cbi.Globals.MinDate) 
						lastWeek = RoundUpTimeToPeriodTime(Bars.Get(idx).Time.Date, PivotRange.Weekly);
					else if (pivotRangeType == PivotRange.Monthly && lastMonth == Cbi.Globals.MinDate) 
						lastMonth = RoundUpTimeToPeriodTime(Bars.Get(idx).Time.Date, PivotRange.Monthly);
					else if (pivotRangeType == PivotRange.Daily && lastDate != Bars.Get(idx).Time.Date 
							|| pivotRangeType == PivotRange.Weekly && lastWeek != RoundUpTimeToPeriodTime(Bars.Get(idx).Time.Date, PivotRange.Weekly)
							|| pivotRangeType == PivotRange.Monthly && lastMonth != RoundUpTimeToPeriodTime(Bars.Get(idx).Time.Date, PivotRange.Monthly))
						continue;

					double		val = series.Get(idx);
					int			x	= (int) (ChartControl.CanvasRight - ChartControl.BarMarginRight - barWidth / 2
										- (ChartControl.BarsPainted - 1) * ChartControl.BarSpace + count * ChartControl.BarSpace);
					int			y	= (int) ((bounds.Y + bounds.Height) - ((val - min ) / Gui.Chart.ChartControl.MaxMinusMin(max, min)) * bounds.Height);

					if (xcounter == 0)
					{
						firstX	= x;
					}
					if (lastX >= 0)
					{
						if (y != lastY) // Problem here is, that last bar of old day has date of new day
							y = lastY;
						path.AddLine(lastX - plot.Pen.Width / 2, lastY, x - plot.Pen.Width / 2, y);
					}
					lastX	= x;
					lastY	= y;
					
					xcounter++;
				}

				graphics.SmoothingMode = SmoothingMode.AntiAlias;
				graphics.DrawPath(plot.Pen, path);
				graphics.SmoothingMode = oldSmoothingMode;
				if ( labels == true )
				{
					if  ( battlelabels == true )
					{
						graphics.DrawString(plot.Name, ChartControl.Font, brush, firstX, lastY - ChartControl.Font.GetHeight(), stringFormat);
					}
					else
					{
						if (plot.Name == "Buyers 20" || plot.Name == "Sellers 20" || plot.Name == "50 Yd")
						{
							graphics.DrawString("", ChartControl.Font, brush, firstX, lastY - ChartControl.Font.GetHeight(), stringFormat);
						}
						else
						{
							graphics.DrawString(plot.Name, ChartControl.Font, brush, firstX, lastY - ChartControl.Font.GetHeight(), stringFormat);			//align label right
							//graphics.DrawString(plot.Name, ChartControl.Font, brush, lastX, lastY - ChartControl.Font.GetHeight() / 2, stringFormat);		//align label left
						}
					}
				}
				else
				{
					if ( battlelabels == true )
					{
						if (plot.Name == "Buyers 20" || plot.Name == "Sellers 20" || plot.Name == "50 Yd")
						{
							graphics.DrawString(plot.Name, ChartControl.Font, brush, firstX, lastY - ChartControl.Font.GetHeight(), stringFormat);
						}
						else
						{
							graphics.DrawString("", ChartControl.Font, brush, firstX, lastY - ChartControl.Font.GetHeight(), stringFormat);			//align label right
							//graphics.DrawString("", ChartControl.Font, brush, lastX, lastY - ChartControl.Font.GetHeight() / 2, stringFormat);		//align label left
						}
					}
					else
					{
						graphics.DrawString("", ChartControl.Font, brush, firstX, lastY - ChartControl.Font.GetHeight(), stringFormat);			//align label right
					}

				}
			}
		}
		#endregion
	}
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private TRO_SM_BattleLines[] cacheTRO_SM_BattleLines = null;

        private static TRO_SM_BattleLines checkTRO_SM_BattleLines = new TRO_SM_BattleLines();

        /// <summary>
        /// Pivot Points with TRO's Battle Lines
        /// </summary>
        /// <returns></returns>
        public TRO_SM_BattleLines TRO_SM_BattleLines()
        {
            return TRO_SM_BattleLines(Input);
        }

        /// <summary>
        /// Pivot Points with TRO's Battle Lines
        /// </summary>
        /// <returns></returns>
        public TRO_SM_BattleLines TRO_SM_BattleLines(Data.IDataSeries input)
        {

            if (cacheTRO_SM_BattleLines != null)
                for (int idx = 0; idx < cacheTRO_SM_BattleLines.Length; idx++)
                    if (cacheTRO_SM_BattleLines[idx].EqualsInput(input))
                        return cacheTRO_SM_BattleLines[idx];

            TRO_SM_BattleLines indicator = new TRO_SM_BattleLines();
            indicator.SetUp();
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;

            TRO_SM_BattleLines[] tmp = new TRO_SM_BattleLines[cacheTRO_SM_BattleLines == null ? 1 : cacheTRO_SM_BattleLines.Length + 1];
            if (cacheTRO_SM_BattleLines != null)
                cacheTRO_SM_BattleLines.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheTRO_SM_BattleLines = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Pivot Points with TRO's Battle Lines
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TRO_SM_BattleLines TRO_SM_BattleLines()
        {
            return _indicator.TRO_SM_BattleLines(Input);
        }

        /// <summary>
        /// Pivot Points with TRO's Battle Lines
        /// </summary>
        /// <returns></returns>
        public Indicator.TRO_SM_BattleLines TRO_SM_BattleLines(Data.IDataSeries input)
        {
            return _indicator.TRO_SM_BattleLines(input);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Pivot Points with TRO's Battle Lines
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.TRO_SM_BattleLines TRO_SM_BattleLines()
        {
            return _indicator.TRO_SM_BattleLines(Input);
        }

        /// <summary>
        /// Pivot Points with TRO's Battle Lines
        /// </summary>
        /// <returns></returns>
        public Indicator.TRO_SM_BattleLines TRO_SM_BattleLines(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.TRO_SM_BattleLines(input);
        }

    }
}
#endregion
